#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif


#ifdef _WIN32
#include "windows.h"
#endif

#include "stdlib.h"
#include "string.h"
#include "assert.h"

#include "GL/gl.h"
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"

#include "BList.h"

#include "auxiliar.h"
#include "2DCMC.h"
#include "Symbol.h"
#include "GLTile.h"
#include "keyboardstate.h"

#include "GLTManager.h"
#include "SoundManager.h"
#include "SFXManager.h"
#include "MusicManager.h"

#include "KObject.h"
#include "KTile.h"
#include "Column.h"
#include "ColumnComplete.h"
#include "Popolon.h"
#include "Blob.h"


Symbol *kobject_symbol = new Symbol("KObject");
Symbol *ktile_symbol = new Symbol("KTile");
Symbol *ktext_symbol = new Symbol("KText");
Symbol *k3dobject_symbol = new Symbol("K3DObject");
Symbol *column_symbol = new Symbol("Column");
Symbol *columncomplete_symbol = new Symbol("ColumnComplete");

Symbol *kplayer_symbol = new Symbol("kplayer");
Symbol *popolon_symbol = new Symbol("popolon");

Symbol *weapon_symbol = new Symbol("weapon");
Symbol *weaponarrow_symbol = new Symbol("weaponArrow");
Symbol *weapondarrow_symbol = new Symbol("weaponDArrow");
Symbol *weaponknife_symbol = new Symbol("weaponKnife");
Symbol *weapondknife_symbol = new Symbol("weaponDKnife");
Symbol *weaponboomerang_symbol = new Symbol("weaponBoomerang");

Symbol *kenemy_symbol = new Symbol("kenemy");
Symbol *blob_symbol = new Symbol("blob");
Symbol *satyr_symbol = new Symbol("satyr");

KObject *KObject_create(Symbol *name, int x, int y, int sfx_volume, List<int> *parameters,GLTManager *GLTM, SFXManager *SFXM)
{
	if (name->cmp(ktile_symbol)) return new KTile(x,y,0);
	if (name->cmp(column_symbol)) return new Column(x,y,0);
	if (name->cmp(columncomplete_symbol)) return new ColumnComplete(x,y,0);
	if (name->cmp(popolon_symbol)) return new Popolon(x,y,sfx_volume,GLTM,SFXM,*(parameters->operator [](0)));
	if (name->cmp(blob_symbol)) return new Blob(x,y,sfx_volume,GLTM);
	if (name->cmp(satyr_symbol)) return new Blob(x,y,sfx_volume,GLTM);

    assert(false);

    return 0;
} /* KObject_create */

